' ViewFolder.VBS V1.08 (C) yoshioka.teruo@nifty.com 2006-01-22
' ViewFolder.VBS shows file list of active explorer.
' Usage: Start ViewFolder.VBS

Option Explicit
Const OLECMDID_SAVE=3
Const OLECMDEXECOPT_DODEFAULT=0
Dim fso
Dim wShell
Dim Shell
Dim ie

Set fso=CreateObject("Scripting.FileSystemObject")
Set wShell=CreateObject("WScript.Shell") 
Set Shell=CreateObject("Shell.Application") 

Set ie=Shell.Windows().Item()
If ie Is Nothing Then
  ie=Empty
ElseIf Not Test(ie) Then
  For Each ie In Shell.Windows()
    If Test(ie) Then Exit For
  Next
End If
If IsEmpty(ie) Then
  WScript.Echo "No Explorer Found."
  WScript.Quit
End If

Function Test(ie)
If ie.ReadyState<>4 Then
ElseIf ie.Busy Then
ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual") Then
  Test=True
End If
End Function

Dim Folder
Dim Title
Dim tPath
Dim StdOut
Dim COL:COL=50
Dim k
Dim Name
Dim SizeColumn
Dim FolderItem
Dim Size
Dim FolderItemSize

Set Folder=ie.Document.Folder
Title=GetPath(ie)
If Title="" Then
  Title=Folder.Title
ElseIf Left(Title,2)="::" Then
  Title=Folder.Title & " " & Title
End If

Function GetPath(ie)
On Error Resume Next
GetPath=Folder.Items().Item().Path
End Function

tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetBaseName(fso.GetTempName())&".htm")
Set StdOut=fso.CreateTextFile(tPath,,True)

StdOut.WriteLine "<html><head>"
StdOut.WriteLine "<title>" & Title & "</title>"
StdOut.WriteLine "</head><body>"
StdOut.WriteLine "<table BORDER>"
StdOut.WriteLine "<caption>" & Title & "</caption>"

For COL=COL To 0 Step -1
  If Folder.GetDetailsOf(,COL)<>"" Then Exit For
Next

StdOut.WriteLine "<tr>"
For k=0 To COL
  Name=Folder.GetDetailsOf(,k)
  StdOut.WriteLine "<td>"&Name&"</td>"
  Select Case Name
  Case "TCY","̃TCY" SizeColumn=k
  End Select
Next
StdOut.WriteLine "</tr>"

For Each FolderItem In Folder.Items()
  StdOut.WriteLine "<tr>"
  For k=0 To COL
    If k=SizeColumn Then
      Size=FolderItem.ExtendedProperty("Size")
      Rem VarType(Size) 21(Integer?) or 0(Empty)
      If IsEmpty(Size) Then 
      Else
        FolderItemSize=FolderItem.Size
        If FolderItemSize Then
          Size=FolderItemSize	'CAB 0
        Else
          Size=CStr(Size)	'ݔ cluster size
        End If
      End If
    Else
      Size=""
    End If
    If Size<>"" Then
      StdOut.WriteLine "<td>"&Size&"</td>"
    Else
      StdOut.WriteLine "<td>"&Folder.GetDetailsOf(FolderItem,k)&"</td>"
    End If
  Next
  StdOut.WriteLine "</tr>"
Next

StdOut.WriteLine "</table></body></html>"

StdOut.Close

Set ie=CreateObject("InternetExplorer.Application")
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.designMode="On"
ie.Navigate tPath
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.charset="shift_jis"
ie.ExecWB OLECMDID_SAVE,OLECMDEXECOPT_DODEFAULT
ie.Document.designMode="Off"
ie.Visible=True
If Not ie.Document.hasFocus Then
  wShell.SendKeys "%{Tab}"
End If
Do While TypeName(ie)="IWebBrowser2"
  WScript.Sleep 100
Loop
If fso.FileExists(tPath) Then fso.DeleteFile tPath

WScript.Quit
