' ViewFolder2txt.VBS V1.07 (C) yoshioka.teruo@nifty.com 2006-01-12
' ViewFolder2txt.VBS shows file list of active explorer.
' Usage: Start ViewFolder2txt.VBS

Option Explicit
Dim fso
Dim wShell
Dim Shell
Dim ie
Dim Start:Start=Timer

Set fso=CreateObject("Scripting.FileSystemObject")
Set wShell=CreateObject("WScript.Shell") 
Set Shell=CreateObject("Shell.Application") 

Set ie=Shell.Windows().Item()
If ie Is Nothing Then
  ie=Empty
ElseIf Not Test(ie) Then
  For Each ie In Shell.Windows()
    If Test(ie) Then Exit For
  Next
End If
If IsEmpty(ie) Then
  WScript.Echo "No Explorer Found."
  WScript.Quit
End If

Function Test(ie)
If ie.ReadyState<>4 Then
ElseIf ie.Busy Then
ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual") Then
  Test=True
End If
End Function

Dim Folder
Dim Title
Dim tPath
Dim StdOut
Dim COL:COL=50
Dim Rows
Dim Columns
Dim k
Dim Name
Dim SizeColumn
Dim FolderItem
Dim Size
Dim FolderItemSize
Dim j
Dim w
Dim wa:ReDim wa(COL)

Set Folder=ie.Document.Folder
Title=GetPath(ie)
If Title="" Then
  Title=Folder.Title
ElseIf Left(Title,2)="::" Then
  Title=Folder.Title & " " & Title
End If

Function GetPath(ie)
On Error Resume Next
GetPath=Folder.Items().Item().Path
End Function

tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
Set StdOut=fso.CreateTextFile(tPath)

StdOut.WriteBlankLines 1
Write Title
StdOut.Write vbCrLf
StdOut.WriteBlankLines 1

For COL=COL To 0 Step -1
'  WScript.Echo i,Folder.GetDetailsOf(,COL)
  If Folder.GetDetailsOf(,COL)<>"" Then Exit For
Next

Rows=Array()
Columns=Array()
For k=0 To COL
  Name=Folder.GetDetailsOf(,k)
  Push Columns,Name
  Select Case Name
  Case "TCY","̃TCY" SizeColumn=k
  End Select
Next
Push Rows,Columns

For Each FolderItem In Folder.Items()
  Columns=Array()
  For k=0 To COL
    If k=SizeColumn Then
      Size=FolderItem.ExtendedProperty("Size")
      Rem VarType(Size) 21(Integer?) or 0(Empty)
      If IsEmpty(Size) Then 
      Else
        FolderItemSize=FolderItem.Size
        If FolderItemSize Then
          Size=FolderItemSize	'CAB 0
        Else
          Size=CStr(Size)	'ݔ cluster size
        End If
      End If
    Else
      Size=""
    End If
    If Size<>"" Then
      Push Columns,Size
    Else
      Push Columns,Folder.GetDetailsOf(FolderItem,k)
    End If
  Next
  Push Rows,Columns
Next

For j=1 To UBound(Rows)
  For k=0 To COL
    w=LenA(Rows(j)(k))
    If wa(k)<w Then wa(k)=w
  Next
Next

For k=0 To COL
  w=LenA(Rows(0)(k))
  If wa(k) Then If wa(k)<w Then wa(k)=w
Next

For COL=COL To 0 Step -1
  If wa(COL) Then Exit For
Next

For j=0 To UBound(Rows)
  For k=0 To COL
    If wa(k) Then
      Write Pad(Rows(j)(k),wa(k))
      If k<COL Then StdOut.Write " "
    End If
  Next
  StdOut.Write vbCrLf
Next

StdOut.Close
'MsgBox Timer-Start
wShell.Run "NotePad.EXE " & tPath,,True
fso.DeleteFile tPath
WScript.Quit

Function Pad(str,m)
Dim k
k=m-LenA(str)
If k<0 Then k=0
Pad=str & String(k," ")
End Function

Function LenA(str)
Dim k
For k=1 To Len(str)
  If Asc(Mid(str,k,1))<0 Then
    LenA=LenA+2
  Else
    LenA=LenA+1
  End If
Next
End Function

Sub Write(ByVal Text)
Text=Replace(Text,ChrW(&HA0)," ") 	'&#160;&nbsp;sp
Text=Replace(Text,ChrW(&HA9),"(C)") 	'&#169;&copy;C
Text=Replace(Text,ChrW(&HAE),"(R)") 	'&#174;&reg;R
Text=Replace(Text,ChrW(&H2013),"-") 	'&#8211;&ndash;?
Text=Replace(Text,ChrW(&H2014),"|") 	'&#8212;&mdash;?
Text=Replace(Text,ChrW(&H02DC),"~") 	'&#732;&tilde;?
Text=Replace(Text,ChrW(&H2122),"TM") 	'&#8482;&trade;?

Dim char
Dim k
Dim code

On Error Resume Next
StdOut.Write Text
If Err<>0 Then
  On Error GoTo 0
  For k=1 To Len(Text)
    char=Mid(Text,k,1)
    On Error Resume Next
    StdOut.Write char
    If Err<>0 Then
      On Error GoTo 0
      code=AscW(char)
      If code<0 Then code=code+256*256
      char="&#"&code&";"
      StdOut.Write char
    Else
      On Error GoTo 0
    End If
  Next
Else
  On Error GoTo 0
End If
End Sub

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
